from selenium import webdriver
import unittest, time


class NewVisitorTest(unittest.TestCase):
    def setUp(self):
        self.browser = webdriver.Firefox()

    def tearDown(self):
        self.browser.quit()

    def test_froyo_shop_home(self):
        # Cian has heard about the Good Place FroYo Shop so, he goes to check out its homepage
        self.browser.get('http://localhost:8000/index')
        # He notices the page title and header mention
        # The Good Place Froyo Shopz
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))
        #He notices a list
        main_list = self.browser.find_element_by_id('main_list')
        self.assertEqual('ul',main_list.tag_name)

    def test_froyo_create_form_ingredients(self):
         # He noticed that he can create a form for the ingredients so he went there and he noticed the header and title Ingredients - Create Form so he clicked it
        self.browser.get('http://localhost:8000/index')
        create_ingredient = self.browser.find_element_by_id('ingredients_create_form')
        create_ingredient.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/ingredients/create_form',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("ingredients_create_form_header"))
        self.assertIn('Ingredients - Create Form', self.browser.title)
        # After creating the ingredient, he went back home
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))
        

    def test_froyo_update_form_ingredients(self):
        # He noticed that he can also update the forms so he went there and he noticed the header and title Ingredients - Update Form so he clicked it and updated his form
        self.browser.get('http://localhost:8000/index')
        update_ingredient = self.browser.find_element_by_id('ingredients_update_form')
        update_ingredient.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/ingredients/update_form',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("ingredients_update_form_header"))
        self.assertIn('Ingredients - Update Form', self.browser.title)
        # After Updating the ingredient, he went back home
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))
        
        

    def test_froyo_display_detail_ingredients(self):
        # He noticed that there are details for the ingredients so he went there and he noticed the header and title Ingredients - Detail

        self.browser.get('http://localhost:8000/index')
        detail_ingredient = self.browser.find_element_by_id('ingredients_detail')
        detail_ingredient.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/ingredients/detail',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("ingredients_detail_header"))
        self.assertIn('Ingredients - Detail', self.browser.title)
        # After this, he went back home
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))


    def test_froyo_display_list_ingredients(self):
        # He noticed that there are also lists for the ingredients so he went there and he noticed the header and title Ingredients - List

        self.browser.get('http://localhost:8000/index')
        list_ingredient = self.browser.find_element_by_id('ingredients_list')
        list_ingredient.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/ingredients/list',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("ingredients_list_header"))
        self.assertIn('Ingredients - List', self.browser.title)
        # After this, he went back home
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))

    def test_froyo_create_form_orders(self):
        #He noticed that he can create a form to create an order so he went there and he noticed the header and title Orders - Create Form

        self.browser.get('http://localhost:8000/index')
        create_order = self.browser.find_element_by_id('orders_create_form')
        create_order.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/orders/create_form',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("orders_create_form_header"))
        self.assertIn('Orders - Create Form', self.browser.title)
        # After creating the form, he went back home
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))



    def test_froyo_update_form_orders(self):
        #He noticed that he can update a form to update an order so he went there and he noticed the header and title Orders - Update Form

        self.browser.get('http://localhost:8000/index')
        update_order = self.browser.find_element_by_id('orders_update_form')
        update_order.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/orders/update_form',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("orders_update_form_header"))
        self.assertIn('Orders - Update Form', self.browser.title)
        # After Updating the order, he went back home
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))

      

    def test_froyo_display_detail_orders(self):
        #He also wanted to look at the detail of a record for an order so he went and looked at one and he noticed the header and title Orders - Detail

        
        self.browser.get('http://localhost:8000/index')
        detail_order = self.browser.find_element_by_id('orders_detail')
        detail_order.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/orders/detail',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("orders_detail_header"))
        self.assertIn('Orders - Detail', self.browser.title)
        # After this, he went back home
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))

        
    def test_froyo_display_list_orders(self):
        #He also wanted to look at the list records for orders so he went and he noticed the header and title Orders - List

        self.browser.get('http://localhost:8000/index')
        list_order = self.browser.find_element_by_id('orders_list')
        list_order.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/orders/list',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("orders_list_header"))
        # After this, he went back home
        self.assertIn('Orders - List', self.browser.title)
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))
    
    def test_froyo_create_form_recipes(self):
        #He noticed that he can create a form for a recipe so he went there and he noticed the header and title Recipes - Create Form

        self.browser.get('http://localhost:8000/index')
        create_recipe = self.browser.find_element_by_id('recipe_create_form')
        create_recipe.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/recipes/create_form',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("recipes_create_form_header"))
        self.assertIn('Recipes - Create Form', self.browser.title)
        # After this, he went back home
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))

    def test_froyo_update_form_recipes(self):
        #He noticed that he can update a form for a recipe so he went there and he noticed the header and title Recipes - Update Form

        self.browser.get('http://localhost:8000/index')
        update_recipe = self.browser.find_element_by_id('recipe_update_form')
        update_recipe.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/recipes/update_form',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("recipes_update_form_header"))
        self.assertIn('Recipes - Update Form', self.browser.title)
        # After this, he went back home
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))
        
    def test_froyo_display_detail_recipes(self):
        #He also wanted to look at the detail of a record for a recipe so he went and looked at one and he noticed the header and title Recipes - Detail

        self.browser.get('http://localhost:8000/index')
        detail_recipe = self.browser.find_element_by_id('recipe_detail')
        detail_recipe.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/recipes/detail',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("recipes_detail_header"))
        self.assertIn('Recipes - Detail', self.browser.title)
        # After this, he went back home
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))

    def test_froyo_display_list_recipes(self):
        #He also wanted to look at the list records for recipes so he went and he noticed the header and title Recipes - List

        self.browser.get('http://localhost:8000/index')
        list_recipe = self.browser.find_element_by_id('recipe_list')
        list_recipe.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/recipes/list',self.browser.current_url)
        self.assertTrue(self.browser.find_element_by_id("recipes_list_header"))
        # After this, he went back home
        self.assertIn('Recipes - List', self.browser.title)
        home = self.browser.find_element_by_id('home')
        home.click()
        time.sleep(1)
        self.assertEqual('http://localhost:8000/index',self.browser.current_url)
        self.assertIn('The Good Place FroYo Shop', self.browser.title)
        self.assertTrue(self.browser.find_element_by_id("header_home"))

if __name__ == '__main__':
    unittest.main(warnings='ignore')
